diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
new file mode 100644
index 000000000..1c9369df2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
@@ -0,0 +1,226 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
+
+public class BlockLogicGrowthRubyglass extends BlockLogic {
+
+	public static final int DIRECTION_MASK = 0b0000_0111;
+	public static final int SHAPE_MASK = 0b0001_1000;
+
+	public static final int STATE_BUD = 0b0000_0000;
+	public static final int STATE_BOTTOM = 0b0000_1000;
+	public static final int STATE_TOP = 0b0001_0000;
+
+	public BlockLogicGrowthRubyglass(final @NotNull Block<?> block, final @NotNull Material material) {
+		super(block, material);
+	}
+
+	@Override
+	public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+		int data = source.getBlockData(tilePos);
+		int shape = data & SHAPE_MASK;
+		if(shape == STATE_BUD) return null;
+		else return super.getCollisionAABB(source, tilePos);
+	}
+
+	@Override
+	public boolean isSolidRender() {
+		return false;
+	}
+
+	@Override
+	public boolean isCubeShaped() {
+		return false;
+	}
+
+	@Override
+	public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc pos, final @NotNull Block<?> neighborBlock) {
+		int data = world.getBlockData(pos);
+		int shape = data & SHAPE_MASK;
+		Direction dir = Direction.fromId(data & DIRECTION_MASK);
+
+		if (!this.canStay(world, pos)) {
+			this.dropWithCause(world, EnumDropCause.IMPROPER_TOOL, pos, data, null, null);
+			world.playBlockEvent(pos, LevelListener.EVENT_BLOCK_BREAK, id());
+			world.setBlockTypeNotify(pos, Blocks.AIR);
+			return;
+		}
+
+		if (shape == STATE_BOTTOM) {
+			TilePos topPos = pos.add(dir, new TilePos());
+			int topMeta = world.getBlockData(topPos);
+			if (world.getBlockType(topPos) != this.block || (topMeta & SHAPE_MASK) != STATE_TOP) {
+				world.setBlockTypeDataNotify(pos, this.block, STATE_BUD | dir.id);
+			}
+		}
+	}
+
+	@Override
+	public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+		TilePos anchorPos = tilePos.add(side.direction().opposite(), new TilePos());
+		Block<?> anchorBlock = world.getBlockType(anchorPos);
+
+		if (anchorBlock == this.block) {
+			int anchorMeta = world.getBlockData(anchorPos);
+			int anchorShape = anchorMeta & SHAPE_MASK;
+
+			if (anchorShape == STATE_BUD) {
+				Direction budDir = Direction.fromId(anchorMeta & DIRECTION_MASK);
+
+				if (budDir == side.direction()) return true;
+
+				if (world.getBlockType(tilePos) == Blocks.AIR) {
+					TilePos growthPos = anchorPos.add(budDir, new TilePos());
+                    return world.getBlockType(growthPos) == Blocks.AIR;
+				}
+				return false;
+			}
+		}
+
+		return world.isBlockNormalCube(anchorPos);
+	}
+
+	@Override
+	public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+		if (!super.canPlaceAt(world, tilePos)) return false;
+
+		for (Side side : Side.values()) {
+			TilePos anchorPos = tilePos.add(side.direction().opposite(), new TilePos());
+
+			if (world.isBlockNormalCube(anchorPos)) return true;
+
+			if (world.getBlockType(anchorPos) == this.block) {
+				int meta = world.getBlockData(anchorPos);
+				int shape = meta & SHAPE_MASK;
+				Direction dir = Direction.fromId(meta & DIRECTION_MASK);
+
+				if (shape == STATE_BUD) {
+					if (dir == side.direction()) return true;
+
+					if (world.getBlockType(tilePos) == Blocks.AIR) {
+						TilePos growthPos = anchorPos.add(dir, new TilePos());
+						if (world.getBlockType(growthPos) == Blocks.AIR) {
+							return true;
+						}
+					}
+				}
+			}
+		}
+		return false;
+	}
+
+	@Override
+	public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+		TilePos clickedAnchor = tilePos.add(side.direction().opposite(), new TilePos());
+
+		if (world.getBlockType(clickedAnchor) == this.block) {
+			int data = world.getBlockData(clickedAnchor);
+			if ((data & SHAPE_MASK) == STATE_BUD) {
+				Direction budDir = Direction.fromId(data & DIRECTION_MASK);
+				TilePos growthPos = clickedAnchor.add(budDir, new TilePos());
+
+				if (!tilePos.equals(growthPos) && world.getBlockType(growthPos) == Blocks.AIR) {
+					world.setBlockTypeNotify(tilePos, Blocks.AIR);
+					world.setBlockData(clickedAnchor, STATE_BOTTOM | (data & DIRECTION_MASK));
+					world.markBlockNeedsUpdate(clickedAnchor);
+					world.setBlockTypeDataNotify(growthPos, this.block, STATE_TOP | (data & DIRECTION_MASK));
+					return;
+				}
+				else if (tilePos.equals(growthPos)) {
+					world.setBlockData(clickedAnchor, STATE_BOTTOM | (data & DIRECTION_MASK));
+					world.markBlockNeedsUpdate(clickedAnchor);
+					world.setBlockTypeDataNotify(tilePos, this.block, STATE_TOP | (data & DIRECTION_MASK));
+					return;
+				}
+			}
+		}
+
+		if (world.isBlockNormalCube(clickedAnchor)) {
+			world.setBlockTypeDataNotify(tilePos, this.block, STATE_BUD | side.direction().id);
+			return;
+		}
+
+		for (Side fallback : Side.values()) {
+			TilePos fallbackAnchor = tilePos.add(fallback.direction.opposite(), new TilePos());
+			if (world.isBlockNormalCube(fallbackAnchor)) {
+				world.setBlockTypeDataNotify(tilePos, this.block, STATE_BUD | fallback.direction.id);
+				return;
+			}
+		}
+	}
+
+	@Override
+	public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+		int data = world.getBlockData(tilePos);
+		int shape = data & SHAPE_MASK;
+		Direction dir = Direction.fromId(data & DIRECTION_MASK);
+
+		if (shape == STATE_TOP) {
+			TilePos bottomPos = tilePos.add(dir.opposite(), new TilePos());
+			return world.getBlockType(bottomPos) == this.block &&
+					(world.getBlockData(bottomPos) & SHAPE_MASK) == STATE_BOTTOM;
+		} else {
+			TilePos anchorPos = tilePos.add(dir.opposite(), new TilePos());
+			return world.isBlockNormalCube(anchorPos);
+		}
+	}
+
+	@Override
+	public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+		int data = source.getBlockData(tilePos);
+		int shape = data & SHAPE_MASK;
+		Direction dir = Direction.fromId(data & DIRECTION_MASK);
+
+		double height;
+		double min = 5.0 / 16.0;
+		double max = 11.0 / 16.0;
+		if (shape == STATE_TOP) {
+			height = 11.0 / 16.0;
+		} else if (shape == STATE_BOTTOM) {
+			min = 3.0 / 16.0;
+			max = 13.0 / 16.0;
+			height = 1.0;
+		} else {
+			height = 12.0 / 16.0;
+		}
+
+        return switch (dir) {
+            case UP -> new AABBd(min, 0.0, min, max, height, max);                // +Y
+            case DOWN -> new AABBd(min, 1.0 - height, min, max, 1.0, max);  // -Y
+            case SOUTH -> new AABBd(min, min, 0.0, max, max, height);             // +Z
+            case NORTH -> new AABBd(min, min, 1.0 - height, max, max, 1.0); // -Z
+            case EAST -> new AABBd(0.0, min, min, height, max, max);              // +X
+            case WEST -> new AABBd(1.0 - height, min, min, 1.0, max, max);  // -X
+            default -> new AABBd(min, 0.0, min, max, height, max);
+        };
+	}
+
+	@Override
+	public ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+		if (dropCause != EnumDropCause.SILK_TOUCH) {
+			return null;
+		}
+
+		int shape = data & SHAPE_MASK;
+
+		if (shape == STATE_BOTTOM) {
+			return new ItemStack[] { new ItemStack(this.block, 2) };
+		}
+
+		return new ItemStack[] { new ItemStack(this.block, 1) };
+	}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
index 64492b0b8..013332665 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -2,6 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.animal.MobWolf;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
@@ -14,13 +17,27 @@ import org.jetbrains.annotations.Nullable;
 public class BlockLogicLayerAsh extends BlockLogicLayerBase
 {
 
-	public BlockLogicLayerAsh(Block<? extends BlockLogicLayerBase> block, Block<?> fullBlock, Material material)
+    public BlockLogicLayerAsh(Block<? extends BlockLogicLayerBase> block, Block<?> fullBlock, Material material)
     {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         block.setTicking(true);
     }
 
+    @Override
+    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+        TilePos emberPos = tilePos.down(new TilePos());
+
+        if (world.getBlockId(emberPos.x(), emberPos.y(), emberPos.z()) == Blocks.EMBER.id()) {
+            BlockLogic logic = Blocks.EMBER.getLogic();
+            if (logic instanceof BlockLogicEmber) {
+                if(entity instanceof Player || entity instanceof MobWolf) {
+                    ((BlockLogicEmber) logic).ignite(world, emberPos, entity);
+                }
+            }
+        }
+    }
+
     public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
         int myMetadata = world.getBlockData(tilePos);
         if (myMetadata == 0x7) return;
@@ -35,20 +52,19 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos down = tilePos.down(new TilePos());
         Block<?> b = world.getBlockType(down);
-        if(b == null || !b.isSolidRender()) {
-        	return false;
+        if(!b.isSolidRender()) {
+            return false;
         } else {
-        	Material material = world.getBlockMaterial(down);
+            Material material = world.getBlockMaterial(down);
             return material.blocksMotion();
         }
     }
 
     @Override
     public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
@@ -58,9 +74,8 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
-            case SILK_TOUCH -> new ItemStack[]{new ItemStack(this, data + 1)};
-            case PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
+            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
             default -> null;
         };
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
index 495b14a2e..a0639d527 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
@@ -22,7 +22,7 @@ public class BlockLogicLog extends BlockLogicAxisAligned {
                 for (queryPos.y = tilePos.x() - r; queryPos.y <= tilePos.y() + r; queryPos.y++) {
                     for (queryPos.z = -tilePos.x() - r; queryPos.z <= tilePos.z() + r; queryPos.z++) {
                         Block<?> block = world.getBlockType(queryPos);
-                        if (!(block != null && block.getLogic() instanceof BlockLogicLeavesBase)) {
+                        if (!(block.getLogic() instanceof BlockLogicLeavesBase)) {
                             continue;
                         }
                         int leavesMeta = world.getBlockData(queryPos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
index 448ef8f85..4083ba26a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMagma.java
@@ -54,7 +54,7 @@ public class BlockLogicMagma extends BlockLogic {
         TilePos queryPos = new TilePos();
         for (final var dir : Direction.all) {
             Block<?> block = world.getBlockType(tilePos.add(dir, queryPos));
-            Material adjacentMaterial = block == null ? Materials.AIR : block.getMaterial();
+            Material adjacentMaterial = block.getMaterial();
             if (adjacentMaterial == Materials.WATER) {
                 return false;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNodeRubyglass.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRubyglass.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicNodeRubyglass.java
index 8a32ca537..52c12fe06 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNodeRubyglass.java
@@ -9,11 +9,11 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicOreRubyglass extends BlockLogicRubyglass
+public class BlockLogicNodeRubyglass extends BlockLogicRubyglass
 {
     public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
 
-    public BlockLogicOreRubyglass(@NotNull Block<?> block){
+    public BlockLogicNodeRubyglass(@NotNull Block<?> block){
         super(block);
         variantMap.put(Blocks.RUBYGLASS_COLUMN.id(), block.id());
     }
@@ -22,7 +22,7 @@ public class BlockLogicOreRubyglass extends BlockLogicRubyglass
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
             case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
-            case EXPLOSION, PROPER_TOOL, PISTON_CRUSH -> new ItemStack[]{new ItemStack(Items.RUBYGLASS_CRYSTAL)};
+            case EXPLOSION, PROPER_TOOL, PISTON_CRUSH -> new ItemStack[]{new ItemStack(Items.RUBYGLASS)};
             default -> null;
         };
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index 28070ac04..782117b85 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -6,10 +6,14 @@ import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
@@ -48,6 +52,20 @@ public class BlockLogicOreRedstone extends BlockLogic {
 
     @Override
     public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+
+        if(player.getHeldItem() == null || !(player.getHeldItem().getItem() instanceof ItemBlock)){
+            if(block == Blocks.ORE_REDSTONE_PERMAFROST || block == Blocks.ORE_REDSTONE_GLOWING_PERMAFROST){
+                player.swingItem();
+                world.playSoundEffectAtTile(player, SoundCategory.WORLD_SOUNDS, tilePos, "step.permafrost", 1F, 0.8F + world.rand.nextFloat() * 0.1F);
+            } else {
+                player.swingItem();
+                world.playSoundEffectAtTile(player, SoundCategory.WORLD_SOUNDS, tilePos, "step.stone", 1F, 0.8F + world.rand.nextFloat() * 0.1F);
+            }
+            world.playSoundEffectAtTile(player, SoundCategory.WORLD_SOUNDS, tilePos, "random.fizz", 0.1F, 2F);
+            world.playSoundEffectAtTile(player, SoundCategory.WORLD_SOUNDS, tilePos, "random.fizz", 0.1F, 1.4F);
+        }
+
+
         lightRedstone(world, tilePos);
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
new file mode 100644
index 000000000..7499cab16
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
@@ -0,0 +1,74 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class BlockLogicRubyglassCrystal extends BlockLogicTransparent {
+	public BlockLogicRubyglassCrystal(@NotNull Block<?> block) {
+		super(block, Materials.ICE);
+		block.friction = 0.98F;
+	}
+
+	@Override
+	public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+		return switch (dropCause) {
+			case PICK_BLOCK, SILK_TOUCH -> new ItemStack[]{new ItemStack(this)};
+			default -> null;
+		};
+	}
+
+	@Override
+	public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+		if (world.isClientSide) return;
+
+		int data = world.getBlockData(tilePos);
+		int nextData = data + 1;
+
+		if (nextData >= 3) {
+			world.setBlockType(tilePos, Blocks.AIR);
+		} else {
+			world.setBlockDataNotify(tilePos, nextData);
+		}
+	}
+
+	@Override
+	public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+		this.onEntityCollision(world, tilePos, entity);
+	}
+
+	@Override
+	public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+		return 0.0F;
+	}
+
+	@Override
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+		if (!world.isClientSide && world.dimension == Dimension.NETHER && rand.nextInt(10) == 0) {
+			int dir = rand.nextInt(6);
+			Direction direction = Direction.fromId(dir);
+			TilePos checkPos = tilePos.add(direction, new TilePos());
+			Block<?> checkBlock = world.getBlockType(checkPos);
+			if (checkBlock == Blocks.AIR) {
+				world.spawnParticle("rubyglassLightning", tilePos.x(), tilePos.y(), tilePos.z(), 0.0F, 0.0F, 0.0F, dir, 1600.0F, true);
+			}
+		}
+	}
+
+	@Override
+	public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+		return 0;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulcatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulCatcher.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulcatcher.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulCatcher.java
index 8d616a0f7..3050d08ba 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulcatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulCatcher.java
@@ -4,16 +4,15 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicSoulcatcher extends BlockLogicFlower {
+public class BlockLogicSoulCatcher extends BlockLogicFlower {
 
-    public BlockLogicSoulcatcher(final @NotNull Block<?> block) {
+    public BlockLogicSoulCatcher(final @NotNull Block<?> block) {
         super(block);
         final float f = 0.4F;
         this.setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index 3ce6bd769..e0294b7a3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -176,7 +176,6 @@ public class BlockLogicStairs extends BlockLogic {
     public BlockLogicStairs(@NotNull Block<?> block, @NotNull Block<?> modelBlock) {
         super(block, Materials.STONE);
         this.modelBlock = modelBlock;
-        block.withLightBlock(255);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 15de385de..9825de3f8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -146,7 +146,7 @@ public class BlockLogicStatue extends BlockLogic {
 
         // All else fails - next pose
         statueEntity.nextPose();
-        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.2F);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "scrape", 1.0F, 0.15F + world.rand.nextFloat() * 0.7F);
         return true;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
new file mode 100644
index 000000000..4570f258a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
@@ -0,0 +1,110 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class BlockLogicSulfur extends BlockLogic {
+
+	public BlockLogicSulfur(@NotNull Block<?> block) {
+		super(block, Materials.SOUL_SAND);
+		block.setTicking(true);
+	}
+
+	@Override
+	public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+		return switch (dropCause) {
+			case PICK_BLOCK, SILK_TOUCH -> new ItemStack[]{new ItemStack(this)};
+			default -> new ItemStack[]{new ItemStack(Items.SULFUR, 1 + world.rand.nextInt(2))};
+		};
+	}
+
+	@Override
+	public int tickDelay() {
+		return 20;
+	}
+
+	@Override
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Block<?> block) {
+		world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+	}
+
+	@Override
+	public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+		world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+	}
+
+	public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
+		int acidCount = 0;
+		TilePos queryPos = new TilePos();
+
+		for (Direction dir : Direction.ID_MAP) {
+			Block<?> block = world.getBlockType(tilePos.add(dir, queryPos));
+			Material adjacentMaterial = block.getMaterial();
+			if (adjacentMaterial == Materials.LAVA) return false;
+			if (adjacentMaterial == Materials.WATER) return false;
+			if (adjacentMaterial == Materials.ACID) {
+				acidCount++;
+			}
+		}
+
+		return acidCount >= 3;
+	}
+
+	@Override
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+		if (this.canMelt(world, tilePos)) {
+			world.playBlockEvent(tilePos, LevelListener.EVENT_ACID_SPREAD, 0);
+			world.setBlockTypeNotify(tilePos, Blocks.FLUID_ACID_FLOWING);
+		}
+
+	}
+
+	@Override
+	public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+		world.playSoundEffect(
+			mob,
+			SoundCategory.WORLD_SOUNDS,
+			tilePos.x() + 0.5,
+			tilePos.y() + 0.5,
+			tilePos.z() + 0.5,
+			"step.stone",
+			1.0F,
+			0.8F
+		);
+		this.onPlacedOnSide(world, tilePos, side, xHit, yHit);
+	}
+
+	@Override
+	public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) {
+		super.onDestroyedByPlayer(world, tilePos, side, data, player, item);
+
+		world.playSoundEffect(
+				player,
+				SoundCategory.WORLD_SOUNDS,
+				tilePos.x() + 0.5,
+				tilePos.y() + 0.5,
+				tilePos.z() + 0.5,
+				"step.stone",
+				1.0F,
+				0.8F
+		);
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfurHardened.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfurHardened.java
new file mode 100644
index 000000000..dec03b406
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfurHardened.java
@@ -0,0 +1,100 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class BlockLogicSulfurHardened extends BlockLogicSulfur {
+
+    public BlockLogicSulfurHardened(@NotNull Block<?> block) {
+        super(block);
+        block.setTicking(false);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        return switch (dropCause) {
+            case PICK_BLOCK, SILK_TOUCH -> new ItemStack[]{new ItemStack(Blocks.SULFUR_HARDENED)};
+            default -> null;
+        };
+    }
+
+    @Override
+    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) {
+        super.onDestroyedByPlayer(world, tilePos, side, data, player, item);
+        world.playSoundEffect(
+            player,
+            SoundCategory.WORLD_SOUNDS,
+            tilePos.x() + 0.5,
+            tilePos.y() + 0.5,
+            tilePos.z() + 0.5,
+            "mob.skeleton",
+            1.0F,
+            2.0F
+        );
+
+        world.playSoundEffect(
+            player,
+            SoundCategory.WORLD_SOUNDS,
+            tilePos.x() + 0.5,
+            tilePos.y() + 0.5,
+            tilePos.z() + 0.5,
+            "step.stone",
+            1.0F,
+            0.8F
+        );
+    }
+
+    @Override
+    public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Block<?> block) {
+    }
+
+    @Override
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+    }
+
+    @Override
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+    }
+
+    @Override
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+        world.playSoundEffect(
+            mob,
+            SoundCategory.WORLD_SOUNDS,
+            tilePos.x() + 0.5,
+            tilePos.y() + 0.5,
+            tilePos.z() + 0.5,
+            "mob.skeleton",
+            1.0F,
+            2.0F
+        );
+        world.playSoundEffect(
+            mob,
+            SoundCategory.WORLD_SOUNDS,
+            tilePos.x() + 0.5,
+            tilePos.y() + 0.5,
+            tilePos.z() + 0.5,
+            "step.stone",
+            1.0F,
+            0.8F
+        );
+        this.onPlacedOnSide(world, tilePos, side, xHit, yHit);
+    }
+}
\ No newline at end of file
